jjb: babeltrace: use --enable-asan (on some builds)
[lttng-ci.git] / scripts / babeltrace / build.sh
index c18423de4deac6d28df702719ce15448e925f748..1d03f72ab7b1811d26ad2fff7ace4d6e54f626cb 100755 (executable)
@@ -1,7 +1,7 @@
-#!/bin/bash -exu
+#!/bin/bash
 #
 # Copyright (C) 2015 Jonathan Rajotte-Julien <jonathan.rajotte-julien@efficios.com>
-#               2016-2019 Michael Jeanson <mjeanson@efficios.com>
+# Copyright (C) 2016-2020 Michael Jeanson <mjeanson@efficios.com>
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -16,6 +16,8 @@
 # You should have received a copy of the GNU General Public License
 # along with this program.  If not, see <http://www.gnu.org/licenses/>.
 
+set -exu
+
 # Version compare functions
 vercomp () {
     set +u
@@ -23,6 +25,8 @@ vercomp () {
         return 0
     fi
     local IFS=.
+    # Ignore the shellcheck warning, we want splitting to happen based on IFS.
+    # shellcheck disable=SC2206
     local i ver1=($1) ver2=($2)
     # fill empty fields in ver1 with zeros
     for ((i=${#ver1[@]}; i<${#ver2[@]}; i++)); do
@@ -44,39 +48,59 @@ vercomp () {
     return 0
 }
 
+# Shellcheck flags the following functions that are unused as "unreachable",
+# ignore that.
+
+# shellcheck disable=SC2317
 verlte() {
-    vercomp "$1" "$2"; local res="$?"
+    vercomp "$1" "$2"
+    local res="$?"
     [ "$res" -eq "0" ] || [ "$res" -eq "2" ]
 }
 
+# shellcheck disable=SC2317
 verlt() {
     vercomp "$1" "$2"; local res="$?"
     [ "$res" -eq "2" ]
 }
 
+# shellcheck disable=SC2317
 vergte() {
     vercomp "$1" "$2"; local res="$?"
     [ "$res" -eq "0" ] || [ "$res" -eq "1" ]
 }
 
+# shellcheck disable=SC2317
 vergt() {
     vercomp "$1" "$2"; local res="$?"
     [ "$res" -eq "1" ]
 }
 
+# shellcheck disable=SC2317
 verne() {
     vercomp "$1" "$2"; local res="$?"
     [ "$res" -ne "0" ]
 }
 
+failed_configure() {
+    # Assume we are in the configured build directory
+    echo "#################### BEGIN config.log ####################"
+    cat config.log
+    echo "#################### END config.log ####################"
+    exit 1
+}
+
+
 # Required variables
 WORKSPACE=${WORKSPACE:-}
 
-arch=${arch:-}
+platform=${platform:-}
 conf=${conf:-}
 build=${build:-}
 cc=${cc:-}
 
+# Controls if the tests are run
+BABELTRACE_RUN_TESTS="${BABELTRACE_RUN_TESTS:=yes}"
 
 SRCDIR="$WORKSPACE/src/babeltrace"
 TMPDIR="$WORKSPACE/tmp"
@@ -95,49 +119,17 @@ gcc)
     export CC=gcc
     export CXX=g++
     ;;
-gcc-4.8)
-    export CC=gcc-4.8
-    export CXX=g++-4.8
-    ;;
-gcc-5)
-    export CC=gcc-5
-    export CXX=g++-5
-    ;;
-gcc-6)
-    export CC=gcc-6
-    export CXX=g++-6
-    ;;
-gcc-7)
-    export CC=gcc-7
-    export CXX=g++-7
-    ;;
-gcc-8)
-    export CC=gcc-8
-    export CXX=g++-8
+gcc-*)
+    export CC=gcc-${cc#gcc-}
+    export CXX=g++-${cc#gcc-}
     ;;
 clang)
     export CC=clang
     export CXX=clang++
     ;;
-clang-3.9)
-    export CC=clang-3.9
-    export CXX=clang++-3.9
-    ;;
-clang-4.0)
-    export CC=clang-4.0
-    export CXX=clang++-4.0
-    ;;
-clang-5.0)
-    export CC=clang-5.0
-    export CXX=clang++-5.0
-    ;;
-clang-6.0)
-    export CC=clang-6.0
-    export CXX=clang++-6.0
-    ;;
-clang-7)
-    export CC=clang-7
-    export CXX=clang++-7
+clang-*)
+    export CC=clang-${cc#clang-}
+    export CXX=clang++-${cc#clang-}
     ;;
 *)
     if [ "x$cc" != "x" ]; then
@@ -152,41 +144,29 @@ if [ "x${CC:-}" != "x" ]; then
 fi
 
 # Set platform variables
-case "$arch" in
-sol10-i386)
-    export MAKE=gmake
-    export TAR=gtar
-    export NPROC=gnproc
-    export PATH="/opt/csw/bin:/usr/ccs/bin:$PATH"
-    export CPPFLAGS="-I/opt/csw/include"
-    export LDFLAGS="-L/opt/csw/lib -R/opt/csw/lib"
-    export PKG_CONFIG_PATH="/opt/csw/lib/pkgconfig"
+case "$platform" in
+macos*)
+    export MAKE=make
+    export TAR=tar
+    export NPROC="getconf _NPROCESSORS_ONLN"
+    export PATH="/opt/local/bin:/opt/local/sbin:/usr/local/bin:/usr/bin:/bin:/usr/sbin:/sbin"
+    export CPPFLAGS="-I/opt/local/include"
+    export LDFLAGS="-L/opt/local/lib"
     export PYTHON="python3"
     export PYTHON_CONFIG="python3-config"
     ;;
 
-sol11-i386)
+freebsd*)
     export MAKE=gmake
-    export TAR=gtar
-    export NPROC=nproc
-    export PATH="$PATH:/usr/perl5/bin"
-    export CPPFLAGS="-I/opt/csw/include"
-    export LDFLAGS="-L/opt/csw/lib -R/opt/csw/lib"
-    export LD_ALTEXEC=/usr/bin/gld
-    export LD=/usr/bin/gld
-    export PYTHON="python3"
-    export PYTHON_CONFIG="python3-config"
-    ;;
-
-macosx)
-    export MAKE=make
     export TAR=tar
     export NPROC="getconf _NPROCESSORS_ONLN"
-    export PATH="/opt/local/bin:/opt/local/sbin:/usr/local/bin:/usr/bin:/bin:/usr/sbin:/sbin"
-    export CPPFLAGS="-I/opt/local/include"
-    export LDFLAGS="-L/opt/local/lib"
+    export CPPFLAGS="-I/usr/local/include"
+    export LDFLAGS="-L/usr/local/lib"
     export PYTHON="python3"
     export PYTHON_CONFIG="python3-config"
+
+    # For bt 1.5
+    export YACC="bison -y"
     ;;
 
 *)
@@ -198,6 +178,10 @@ macosx)
     ;;
 esac
 
+# Print build env details
+print_os || true
+print_tooling || true
+
 # Enter the source directory
 cd "$SRCDIR"
 
@@ -216,6 +200,13 @@ export BABELTRACE_MINIMAL_LOG_LEVEL=TRACE
 # Set configure options and environment variables for each build
 # configuration.
 CONF_OPTS=("--prefix=$PREFIX")
+
+# -Werror is enabled by default in stable-2.0 but won't be in 2.1
+# Explicitly disable it for consistency.
+if vergte "$PACKAGE_VERSION" "2.0"; then
+       CONF_OPTS+=("--disable-Werror")
+fi
+
 case "$conf" in
 static)
     echo "Static lib only configuration"
@@ -246,7 +237,21 @@ prod)
     unset BABELTRACE_MINIMAL_LOG_LEVEL
 
     # Enable the python bindings
-    CONF_OPTS+=("--enable-python-bindings" "--enable-python-bindings-doc" "--enable-python-plugins")
+    CONF_OPTS+=("--enable-python-bindings" "--enable-python-plugins")
+    ;;
+
+doc)
+    echo "Documentation configuration"
+
+    CONF_OPTS+=("--enable-python-bindings" "--enable-python-bindings-doc" "--enable-python-plugins" "--enable-api-doc")
+    ;;
+
+asan)
+    echo "Address Sanitizer configuration"
+
+    # --enable-asan was introduced after 2.0 but don't check the version, we
+    # want this configuration to fail if ASAN is unavailable.
+    CONF_OPTS+=("--enable-asan" "--enable-python-bindings" "--enable-python-plugins")
     ;;
 
 min)
@@ -280,7 +285,7 @@ oot)
     builddir=$(mktemp -d)
     cd "$builddir"
 
-    "$SRCDIR/configure" "${CONF_OPTS[@]}"
+    "$SRCDIR/configure" "${CONF_OPTS[@]}" || failed_configure
     ;;
 
 dist)
@@ -288,7 +293,7 @@ dist)
 
     # Run configure and generate the tar file
     # in the source directory
-    ./configure
+    ./configure || failed_configure
     $MAKE dist
 
     # Create and enter a temporary build directory
@@ -300,7 +305,7 @@ dist)
     $TAR xvf "$SRCDIR"/*.tar.* --strip 1
 
     # Build in extracted source tree
-    ./configure "${CONF_OPTS[@]}"
+    ./configure "${CONF_OPTS[@]}" || failed_configure
     ;;
 
 oot-dist)
@@ -311,7 +316,7 @@ oot-dist)
     cd "$builddir"
 
     # Run configure out of tree and generate the tar file
-    "$SRCDIR/configure"
+    "$SRCDIR/configure" || failed_configure
     $MAKE dist
 
     dist_srcdir="$(mktemp -d)"
@@ -327,12 +332,12 @@ oot-dist)
 
     # Run configure from the extracted distribution tar,
     # out of the source tree
-    "$dist_srcdir/configure" "${CONF_OPTS[@]}"
+    "$dist_srcdir/configure" "${CONF_OPTS[@]}" || failed_configure
     ;;
 
 *)
     echo "Standard in-tree build"
-    ./configure "${CONF_OPTS[@]}"
+    ./configure "${CONF_OPTS[@]}" || failed_configure
     ;;
 esac
 
@@ -346,10 +351,19 @@ $MAKE install DESTDIR="$WORKSPACE"
 
 # Run tests, don't fail now, we want to run the archiving steps
 failed_tests=0
-$MAKE --keep-going check || failed_tests=1
-
-# Copy tap logs for the jenkins tap parser before cleaning the build dir
-rsync -a --exclude 'test-suite.log' --include '*/' --include '*.log' --exclude='*' tests/ "$WORKSPACE/tap"
+if [ "$BABELTRACE_RUN_TESTS" = "yes" ]; then
+       $MAKE --keep-going check || failed_tests=1
+
+       # Copy tap logs for the jenkins tap parser before cleaning the build dir
+       rsync -a --exclude 'test-suite.log' --include '*/' --include '*.log' --exclude='*' tests/ "$WORKSPACE/tap"
+
+       # The test suite prior to 1.5 did not produce TAP logs
+       if verlt "$PACKAGE_VERSION" "1.5"; then
+           mkdir -p "$WORKSPACE/tap/no-log"
+           echo "1..1" > "$WORKSPACE/tap/no-log/tests.log"
+           echo "ok 1 - Test suite doesn't support logging" >> "$WORKSPACE/tap/no-log/tests.log"
+       fi
+fi
 
 # Clean the build directory
 $MAKE clean
This page took 0.031242 seconds and 4 git commands to generate.